unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, XPMan, StdCtrls, Buttons;

type
  TfMain = class(TForm)
    GroupBox1: TGroupBox;
    fname: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    GroupBox2: TGroupBox;
    log: TMemo;
    Openf: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fMain: TfMain;

implementation

uses AboutForm;

{$R *.dfm}

procedure TfMain.FormCreate(Sender: TObject);
begin
application.Title:=fmain.Caption;
end;

procedure ShowError(str:string);
begin
fmain.log.Lines.Add(str);
end;

function GetPackerSecName: string;
const
 sectname: array [0..33] of ShortString =('ASPack','.aspr',
  '.code','kryptor','.lame','Guard','.shrink','.UPX1',
  'PELockNT','PESHLD','Stone','.peshit','PEtite','SC v1.2',
  '.shield','SPLASH','SVKP','tElock','CDLock','.UPX2',
  'HYBRIS','.lcc','Xtreme','.pepack','ZCode','.PECrypt',
  'ORiEN','.y0da','PUNiSHER','.stealth','.UPX0','.PKLITE',
  '.arma','.nfo');
var rend:integer;
begin
  Randomize;
  rend:=random(33);
  result:=sectname[rend];
end;

function AddNewSection(const FileName: string): Boolean;
const
  NewSectionSize = 50;
  NOP: Byte = $90;
  NUL: Byte = $00;

  BYT1: array[0..1]  of byte = ($FF, $E0);
  BYT2: array[0..35] of byte = ($90, $90, $90, $90, $B8,
  $9C, $6F, $46, $77, $89, $02, $83, $C2, $04, $B8, $0F,
  $50, $50, $AA, $89, $02, $B8, $1F, $78, $40, $00, $90,
  $90, $90, $90, $90, $90, $90, $90, $FF, $E0);

type
  TSection = packed record
    Name: array[0..7] of Char;
    VirtualSize: DWORD;
    VirtualAddress: DWORD;
    PhysicalSize: DWORD;
    PhysicalOffset: DWORD;
    PointerToRelocations: DWORD;
    PointerToLinenumbers: DWORD;
    NumberOfRelocations: WORD;
    NumberOfLinenumbers: WORD;
    Characteristics: DWORD;
  end;
var
  FHandle: THandle;
  OFS: OFSTRUCT;
  BytesRead: DWORD;
  EXESig: WORD;
  PESig: DWORD;
  PEHeaderOffset: DWORD;
  ImageBase: DWORD;
  EntryPointRVA: DWORD;
  SizeOfImage: DWORD;
  NumOfSections: WORD;
  Sect_Align: DWORD;
  Characteristics: DWORD;
  Section: TSection;
  MOV: Byte;
  I: DWORD;
  OEP: DWORD;
  ImSZ: DWORD;
  VirAddr: DWORD;
  PhyAddr: DWORD;
begin
  Result:= False;
  if not FileExists(FileName) then
  begin
    ShowError('File not found');
    Exit;
  end;
  FHandle:= OpenFile(PChar(FileName), OFS, OF_READWRITE);
  if (FHandle = INVALID_HANDLE_VALUE) then
  begin
    ShowError('Error at opening file');
    Exit;
  end;
  ReadFile(FHandle, EXESig, SizeOf(EXESig), BytesRead, nil);
  if EXESig <> $5A4D then
  begin
    ShowError('Invalid MZ file');
    Exit;
  end;
  SetFilePointer(FHandle, $3C, nil, 0);
  ReadFile(FHandle, PEHeaderOffset, SizeOf(PEHeaderOffset), BytesRead, nil);
  if PEHeaderOffset = 0 then
  begin
    ShowError('PE header offset not found');
    Exit;
  end;
  SetFilePointer(FHandle, PEHeaderOffset, nil, 0);
  ReadFile(FHandle, PESig, SizeOf(PESig), BytesRead, nil);
  if PESig <> $00004550 then
  begin
    ShowError('Invalid PE file');
    Exit;
  end;
  SetFilePointer(FHandle, PEHeaderOffset + $16, nil, 0);
  ReadFile(FHandle, Characteristics, SizeOf(Characteristics), BytesRead, nil);
  if Characteristics and IMAGE_FILE_DLL <> 0 then
  begin
    ShowError('Can not protect a DLL. Sorry...');
    Exit;
  end;
  SetFilePointer(FHandle, PEHeaderOffset + $50, nil, 0);
  ReadFile(FHandle, SizeOfImage, SizeOf(SizeOfImage), BytesRead, nil);
  SetFilePointer(FHandle, PEHeaderOffset + $34, nil, 0);
  ReadFile(FHandle, ImageBase, SizeOf(ImageBase), BytesRead, nil);
  SetFilePointer(FHandle, PEHeaderOffset + $28, nil, 0);
  ReadFile(FHandle, EntryPointRVA, SizeOf(EntryPointRVA), BytesRead, nil);
  SetFilePointer(FHandle, PEHeaderOffset + $06, nil, 0);
  ReadFile(FHandle, NumOfSections, SizeOf(NumOfSections), BytesRead, nil);
  SetFilePointer(FHandle, PEHeaderOffset + $38, nil, 0);
  ReadFile(FHandle, Sect_Align, SizeOf(Sect_Align), BytesRead, nil);


  SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
  for I:= 1 to NumOfSections do
  begin
    ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
    SetFilePointer(FHandle, -SizeOf(Section), nil, FILE_CURRENT);
    section.Characteristics:= $C0000040;
    WriteFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
  end;

  SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
  for I:= 1 to NumOfSections do
  begin
    ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
    if (EntryPointRVA >= Section.VirtualAddress)
      and (EntryPointRVA < Section.VirtualAddress + Section.VirtualSize) then Break;
  end;
  OEP:=ImageBase+EntryPointRVA;

  SetFilePointer(FHandle, PEHeaderOffset + $F8, nil, 0);
  for I:= 1 to NumOfSections do
   begin
    ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
   end;
  VirAddr:=((section.VirtualAddress+section.VirtualSize+Sect_Align-1) div Sect_Align) * Sect_Align;
  PhyAddr:=section.PhysicalOffset+section.PhysicalSize;

  SetFilePointer(FHandle, PEHeaderOffset + $F8 + NumOfSections * $28 - $28, nil, 0);
  ReadFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
  with Section do
  begin
    VirtualAddress:=  VirAddr;
    VirtualSize:=     NewSectionSize;
    PhysicalOffset:=  PhyAddr;
    PhysicalSize:=    NewSectionSize;
    Characteristics:= $60000020;
    StrPCopy(Name,GetPackerSecName);
  end;

  showerror('Name of new section: '+section.Name);
  SetFilePointer(FHandle, PEHeaderOffset + $50, nil, 0);
  ImSZ:=VirAddr+Section.VirtualSize-section.PhysicalSize;
  WriteFile(FHandle, ImSz, SizeOf(ImSz), BytesRead, nil);

  SetFilePointer(FHandle, PEHeaderOffset + $F8 + NumOfSections * $28, nil, 0);
  WriteFile(FHandle, Section, SizeOf(Section), BytesRead, nil);
  Inc(NumOfSections);
  SetFilePointer(FHandle, PEHeaderOffset + $06, nil, 0);
  WriteFile(FHandle, NumOfSections, SizeOf(NumOfSections), BytesRead, nil);
  showerror('Add new section');
  SetFilePointer(FHandle, PEHeaderOffset + $50, nil, 0);
  ReadFile(FHandle, I, SizeOf(I), BytesRead, nil);
  Inc(I, NewSectionSize);
  SetFilePointer(FHandle, PEHeaderOffset + $50, nil, 0);
  WriteFile(FHandle, I, SizeOf(I), BytesRead, nil);
  showerror('Fix Image Size');
  SetFilePointer(FHandle, PEHeaderOffset + $1C, nil, 0);
  ReadFile(FHandle, I, SizeOf(I), BytesRead, nil);
  showerror('Fix Size of Code');
  SetFilePointer(FHandle, Section.PhysicalOffset + Section.PhysicalSize -
    NewSectionSize, nil, 0);


  // [code] //
  WriteFile(FHandle, NOP,  SizeOf(NOP),  BytesRead, nil);
  WriteFile(FHandle, NOP,  SizeOf(NOP),  BytesRead, nil);
   MOV:=$B8;
  WriteFile(FHandle, MOV,  SizeOf(MOV),  BytesRead, nil);
  WriteFile(FHandle, OEP,  SizeOf(OEP),  BytesRead, nil);
  WriteFile(FHandle, BYT1, SizeOf(BYT1), BytesRead, nil);
   MOV:=$BA;
  WriteFile(FHandle, MOV,  SizeOf(MOV),  BytesRead, nil);
  WriteFile(FHandle, OEP,  SizeOf(OEP),  BytesRead, nil);
  WriteFile(FHandle, BYT2, SizeOf(BYT2), BytesRead, nil);
  // [/code] //

  EntryPointRVA:= Section.PhysicalOffset + Section.VirtualAddress - Section.PhysicalOffset;
  SetFilePointer(FHandle, PEHeaderOffset + $28, nil, 0);
  WriteFile(FHandle, EntryPointRVA, SizeOf(EntryPointRVA), BytesRead, nil);

  showerror('Fix Entrypoint');
  CloseHandle(FHandle);
  Result:= True;
end;

procedure TfMain.BitBtn2Click(Sender: TObject);
begin
 if AddNewSection(fname.Text) then
    ShowError('File successful protected...');
end;

procedure TfMain.BitBtn1Click(Sender: TObject);
begin
if openf.Execute then
   fname.Text:=openf.FileName;
end;

procedure TfMain.BitBtn3Click(Sender: TObject);
begin
fabout.ShowModal;
end;

end.
